<?xml version="1.0"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="text"/>
<xsl:strip-space elements="*"/>

<xsl:include href="util.xslt"/>
	
<xsl:template match="/">
	<xsl:apply-templates select="project"/>
</xsl:template>

<xsl:template match="project">
	<xsl:text>Copyright (C) 2003 W. Michael Petullo &lt;mike@flyn.org&gt;</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:apply-templates select="name"/>
	<xsl:apply-templates select="logo"/>
	<xsl:apply-templates select="one-liner"/>
	<xsl:apply-templates select="usage"/>
	<xsl:apply-templates select="overview"/>
	<xsl:text>= BUILDING =================================================================

To build, cross your fingers and try...

 1. ./configure
 2. make
 3. make install

Read the ``INSTALL'' file for generic detailed information on installing
this program.
	</xsl:text>
	<xsl:apply-templates select="nasty-details"/>
</xsl:template>

<xsl:template match="name">
	<xsl:value-of select="."/> is </xsl:template>

<xsl:template match="one-liner">
	<xsl:value-of select="."/>
	<xsl:value-of select="$cr"/>
</xsl:template>

<xsl:template match="synopsis">
	<xsl:value-of select="."/>
</xsl:template>

<xsl:template match="ulink">
	<A>
	<xsl:attribute name="href">
	<xsl:value-of select="@url"/>
	</xsl:attribute>
	<xsl:apply-templates select="*"/>
	</A>
</xsl:template>

<xsl:template match="overview">
= OVERVIEW =================================================================
	<xsl:value-of select="$cr"/>
	<xsl:apply-templates select="*"/>
</xsl:template>

<xsl:template match="nasty-details">
= NASTY DETAILS ============================================================
	<xsl:value-of select="$cr"/>
	<xsl:apply-templates select="*"/>
</xsl:template>

<xsl:template match="example">
	<xsl:apply-templates select="*"/>
</xsl:template>

<xsl:template match="screen">
	<xsl:value-of select="."/>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
</xsl:template>

</xsl:stylesheet>
