<?xml version="1.0"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="text"/>

<xsl:include href="util.xslt"/>

<xsl:template match="/">
	<xsl:apply-templates select="*" mode="struct"/>
	<xsl:apply-templates select="*" mode="fn_top"/>
	<xsl:apply-templates select="*" mode="while"/>
	<xsl:apply-templates select="*" mode="body"/>
</xsl:template>

<xsl:template match="project" mode="body">
	<xsl:text>	switch (c) {
</xsl:text>
	<xsl:apply-templates select="options" mode="body"/>
	<xsl:text>		default:</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:text>			print_usage(EXIT_FAILURE, NULL, NULL);</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:text>		}</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:text>	}</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:text>}</xsl:text>
	<xsl:value-of select="$cr"/>
</xsl:template>

<xsl:template match="options" mode="body">
	<xsl:for-each select="opt">
		<xsl:if test="longname">
			<xsl:text>		case: '</xsl:text>
			<xsl:value-of select="shortname"/>
			<xsl:text>'</xsl:text>
			<xsl:value-of select="$cr"/>
			<xsl:text>			settings.</xsl:text>
			<xsl:value-of select="longname"/>
			<xsl:choose>
			<xsl:when test="argument">
				<xsl:text> = optarg;</xsl:text>
			</xsl:when>
                        <xsl:otherwise>
				<xsl:text> = 1;</xsl:text>
			</xsl:otherwise>
                        </xsl:choose>
			<xsl:value-of select="$cr"/>
			<xsl:text>			break;</xsl:text>
			<xsl:value-of select="$cr"/>
		</xsl:if>
	</xsl:for-each>
</xsl:template>

<xsl:template match="project/argument" mode="body">
	<xsl:text>		case '</xsl:text>
	<xsl:value-of select="substring (name, 1, 1)"/>
	<xsl:text>':
			settings-&gt;</xsl:text>
	<xsl:value-of select="name"/>
	<xsl:text> = optarg;
			break;
</xsl:text>
</xsl:template>

<xsl:template match="project" mode="fn_top">
	<xsl:text>void parse_args(int argc, char *argv[], settings_t * settings)
{
	int c;
	int opt_index = 0;
	struct option opts[] = {
</xsl:text>
	<xsl:apply-templates select="options" mode="fn_top"/>
	<xsl:text>	{0, 0, 0, 0}</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:text>	};</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
</xsl:template>

<xsl:template match="options" mode="fn_top">
	<xsl:for-each select="opt">
		<xsl:if test="longname">
		<xsl:text>	{"</xsl:text>
		<xsl:value-of select="longname"/>
		<xsl:choose>
		<xsl:when test="argument">
			<xsl:text>", 1, 0, '</xsl:text>
		</xsl:when>
		<xsl:otherwise>
			<xsl:text>", 0, 0, '</xsl:text>
		</xsl:otherwise>
		</xsl:choose>
		<xsl:value-of select="shortname"/>
		<xsl:text>'},</xsl:text>
		<xsl:value-of select="$cr"/>
		</xsl:if>
	</xsl:for-each>
</xsl:template>

<xsl:template match="project" mode="struct">
	<xsl:text>#include &lt;getopt.h&gt;

typedef struct settings_t {
</xsl:text>
	<xsl:apply-templates select="options" mode="struct"/>
	<xsl:text>} settings_t;</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:text>settings_t settings;</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
</xsl:template>

<xsl:template match="options" mode="struct">
	<xsl:for-each select="opt">
		<xsl:if test="longname">
			<xsl:choose>
			<xsl:when test="argument">
				<xsl:text>	char *</xsl:text>
				<xsl:value-of select="longname"/>
				<xsl:text>;</xsl:text>
				<xsl:value-of select="$cr"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>	int </xsl:text>
				<xsl:value-of select="longname"/>
				<xsl:text>;</xsl:text>
				<xsl:value-of select="$cr"/>
			</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
	</xsl:for-each>
</xsl:template>

<xsl:template match="project" mode="while">
	<xsl:text>	while ((c = getopt_long(argc, argv, "</xsl:text>
	<xsl:apply-templates select="options" mode="while"/>
	<xsl:text>", opts, &amp;opt_index)) &gt;= 0) {
	</xsl:text>
</xsl:template>

<xsl:template match="options" mode="while">
	<xsl:for-each select="opt">
		<xsl:if test="longname">
			<xsl:value-of select="shortname"/>
			<xsl:if test="argument">
				<xsl:text>:</xsl:text>
			</xsl:if>
		</xsl:if>
	</xsl:for-each>
</xsl:template>

</xsl:stylesheet>
