<?xml version="1.0"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="text"/>

<xsl:include href="util.xslt"/>

<xsl:template match="/">
	<xsl:apply-templates select="project"/>
</xsl:template>

<xsl:template match="project">
	<xsl:apply-templates select="name"/>
	<xsl:apply-templates select="one-liner"/>
	<xsl:apply-templates select="synopsis"/>
	<xsl:apply-templates select="overview"/>
	<xsl:apply-templates select="nasty-details"/>
	<xsl:apply-templates select="maintainer"/>
</xsl:template>

<xsl:template match="name">
	<xsl:text>.TH </xsl:text>
	<xsl:value-of select="."/>
	<xsl:text> </xsl:text>
	<xsl:value-of select="../mansect"/>
	<xsl:value-of select="$cr"/>
</xsl:template>

<xsl:template match="one-liner">
	<xsl:text>.SH NAME</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:text>.PP</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="../name"/>
	<xsl:text> \- </xsl:text>
	<xsl:value-of select="."/>
	<xsl:value-of select="$cr"/>
</xsl:template>

<xsl:template match="synopsis">
	<xsl:text>.SH SYNOPSIS</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:text>.PP</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:text>.B </xsl:text>
	<xsl:value-of select="../name"/>
	<xsl:text> </xsl:text>
	<xsl:value-of select="."/>
	<xsl:value-of select="$cr"/>
</xsl:template>

<xsl:template match="overview">
	<xsl:text>.SH OVERVIEW</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:apply-templates select="*"/>
</xsl:template>

<xsl:template match="nasty-details">
	<xsl:text>.SH NASTY DETAILS</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:apply-templates select="*"/>
</xsl:template>

<xsl:template match="example">
	<xsl:apply-templates select="*"/>
</xsl:template>

<xsl:template match="maintainer">
	<xsl:text>.SH AUTHORS</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:text>.PP</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="."/>
</xsl:template>

<xsl:template match="para">
	<xsl:text>.PP</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="."/>
	<xsl:value-of select="$cr"/>
</xsl:template>

<xsl:template match="screen">
	<xsl:text>.IP</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:text>.nf</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="."/>
	<xsl:text>.fi</xsl:text>
	<xsl:value-of select="$cr"/>
</xsl:template>

<xsl:template match="variablelist">
	<xsl:for-each select="varlistentry">
	<xsl:text>.TP</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="term"/>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="listitem"/>
	<xsl:value-of select="$cr"/>
	</xsl:for-each>
</xsl:template>

</xsl:stylesheet>
