<?xml version="1.0"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="text"/>
<xsl:strip-space elements="*"/>

<xsl:include href="util.xslt"/>
	
<xsl:template match="/">
	<xsl:apply-templates select="project"/>
</xsl:template>

<xsl:template match="project">
	<xsl:text>%define rel 1</xsl:text><xsl:value-of select="$cr"/>
	<xsl:text>%define prefix /usr</xsl:text><xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:apply-templates select="one-liner"/>
	<xsl:apply-templates select="name"/>
	<xsl:call-template name="version"/>
	<xsl:text>Release: %rel</xsl:text><xsl:value-of select="$cr"/>
	<xsl:apply-templates select="copyright"/>
	<xsl:apply-templates select="rpm-group"/>
	<xsl:text>Source: %name-%{PACKAGE_VERSION}.tar.gz</xsl:text><xsl:value-of select="$cr"/>
	<xsl:text>BuildRoot: %{_tmppath}/%{name}-%{version}-root</xsl:text><xsl:value-of select="$cr"/>
	<xsl:apply-templates select="maintainer"/>
	<xsl:apply-templates select="vendor"/>
	<xsl:text>Distribution: Flyn Linux</xsl:text><xsl:value-of select="$cr"/>
	<xsl:apply-templates select="url"/>
	<xsl:apply-templates select="rpm-requires"/>
	<xsl:value-of select="$cr"/>
	<xsl:apply-templates select="overview"/>
	<xsl:apply-templates select="changelog"/>
	<xsl:apply-templates select="prep"/>
	<xsl:apply-templates select="setup"/>
	<xsl:apply-templates select="build"/>
	<xsl:text>%changelog</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:text>%prep</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:text>%setup</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:text>%build</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:text>CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{prefix}</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:text>make</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:text>%install</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:text>make install DESTDIR=$RPM_BUILD_ROOT</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:apply-templates select="rpm-install"/>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:text>%clean</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:text>rm -rf $RPM_BUILD_ROOT</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:text>%pre</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:text>%post</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:text>%preun</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:text>%postun</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:text>%files</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:text>%defattr(-, root, root)</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:apply-templates select="files"/>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:text>%doc</xsl:text>
	<xsl:value-of select="$tab"/>
	<xsl:text>AUTHORS.gz COPYING.gz ChangeLog.gz INSTALL.gz NEWS.gz README.gz</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:text>%config</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:apply-templates select="config"/>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
</xsl:template>

<xsl:template match="one-liner">
	<xsl:text>Summary: </xsl:text>
	<xsl:value-of select="."/>
	<xsl:value-of select="$cr"/>
</xsl:template>

<xsl:template match="name">
	<xsl:text>Name: </xsl:text>
	<xsl:value-of select="."/>
	<xsl:value-of select="$cr"/>
</xsl:template>

<!-- Should be defined on xsltproc command line with: -->
<!-- -stringparam version x.x.x -->
<xsl:template name="version">
	<xsl:text>Version: </xsl:text>
	<xsl:value-of select="$version"/>
	<xsl:value-of select="$cr"/>
</xsl:template>

<xsl:template match="copyright">
	<xsl:text>Copyright: </xsl:text>
	<xsl:value-of select="."/>
	<xsl:value-of select="$cr"/>
</xsl:template>

<xsl:template match="rpm-group">
	<xsl:text>Group: </xsl:text>
	<xsl:value-of select="."/>
	<xsl:value-of select="$cr"/>
</xsl:template>

<xsl:template match="maintainer">
	<xsl:text>Packager: </xsl:text>
	<xsl:value-of select="."/>
	<xsl:value-of select="$cr"/>
</xsl:template>

<xsl:template match="vendor">
	<xsl:text>Vendor: </xsl:text>
	<xsl:value-of select="."/>
	<xsl:value-of select="$cr"/>
</xsl:template>

<xsl:template match="url">
	<xsl:text>URL: </xsl:text>
	<xsl:value-of select="."/>
	<xsl:value-of select="$cr"/>
</xsl:template>

<xsl:template match="rpm-requires">
	<xsl:text>Requires: </xsl:text>
	<xsl:value-of select="."/>
	<xsl:value-of select="$cr"/>
</xsl:template>

<xsl:template match="overview">
	<xsl:text>%description</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:apply-templates select="*"/>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
</xsl:template>

<xsl:template match="files">
	<xsl:apply-templates select="path"/>
</xsl:template>

<xsl:template match="configs">
	<xsl:apply-templates select="path"/>
</xsl:template>

<xsl:template match="rpm-install">
	<xsl:apply-templates select="command"/>
</xsl:template>

<xsl:template match="path">
	<xsl:value-of select="."/>
	<xsl:value-of select="$cr"/>
</xsl:template>

<xsl:template match="command">
	<xsl:value-of select="."/>
	<xsl:value-of select="$cr"/>
</xsl:template>

</xsl:stylesheet>
