<?xml version="1.0"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="text"/>

<xsl:include href="util.xslt"/>

<xsl:template match="/">
	<xsl:text>#include &lt;stdio.h&gt;</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:apply-templates select="project"/>
	<xsl:value-of select="$cr"/>
	<xsl:value-of select="$cr"/>
	<xsl:text>/* ============================ print_usage () ============================== */
void print_usage(const int exitcode, const char *error, const char *more)
{
    fprintf(stderr, "%s\n", usage);
    if (error)
        fprintf(stderr, "%s: %s.\n\n", error, more);
    exit(exitcode);
}
</xsl:text>
</xsl:template>

<xsl:template match="project">
	<xsl:text>char *usage = </xsl:text>
	<xsl:text>"</xsl:text>
	<xsl:apply-templates select="name"/>
	<xsl:text> </xsl:text>
	<xsl:apply-templates select="synopsis"/>
	<xsl:text>\n\n"</xsl:text>
	<xsl:value-of select="$cr"/>
	<xsl:apply-templates select="options"/>
	<xsl:text>;</xsl:text>
</xsl:template>

<xsl:template match="options">
	<xsl:for-each select="opt">
		<xsl:text>"</xsl:text>
		<xsl:apply-templates select="shortname"/>
		<xsl:apply-templates select="longname"/>
		<xsl:apply-templates select="argument"/>
		<xsl:text>\n"</xsl:text>
		<xsl:value-of select="$cr"/>
		<xsl:text>"	</xsl:text>
		<xsl:value-of select="description"/>
		<xsl:text>\n\n"</xsl:text>
		<xsl:value-of select="$cr"/>
	</xsl:for-each>
</xsl:template>

<xsl:template match="shortname">
	<xsl:text>-</xsl:text>
	<xsl:value-of select="."/>
</xsl:template>

<xsl:template match="longname">
	<xsl:text>, --</xsl:text>
	<xsl:value-of select="."/>
	<xsl:text> </xsl:text>
</xsl:template>

<xsl:template match="argument">
	<xsl:value-of select="."/>
</xsl:template>

</xsl:stylesheet>
