<?xml version="1.0"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="html"/>
	
<xsl:template match="/">
	<HTML>
	<HEAD>
	<TITLE>
	<xsl:value-of select="project/name"/>
	</TITLE>
	<META name="editor" content="xsltproc"></META>
	<STYLE type="text/css">
	@import url('../../flyn.org.css');
	</STYLE>
	</HEAD>
	<BODY>
	<DIV class="side">
	<H1><A href="../../index.html">Home...</A></H1>
	<H1><A href="../index.html">More projects...</A></H1>
	<H1><A href="download.html">Download...</A></H1>
	</DIV>
	<DIV class="main">
	<xsl:apply-templates select="project"/>
	</DIV>
	</BODY>
	</HTML>
</xsl:template>

<xsl:template match="project">
	<xsl:apply-templates select="name"/>
	<xsl:apply-templates select="logo"/>
	<xsl:apply-templates select="one-liner"/>
	<xsl:apply-templates select="usage"/>
	<xsl:apply-templates select="screenshot"/>
	<xsl:apply-templates select="overview"/>
	<xsl:apply-templates select="nasty-details"/>
</xsl:template>

<xsl:template match="name">
	<H1>
	<xsl:value-of select="."/>
	</H1>
</xsl:template>

<xsl:template match="one-liner">
	<P>
	<xsl:value-of select="."/>
	</P>
</xsl:template>

<xsl:template match="synopsis">
	<P>
	<xsl:value-of select="."/>
	</P>
</xsl:template>

<xsl:template match="overview">
	<H1>Overview</H1>
	<xsl:apply-templates select="*"/>
</xsl:template>

<xsl:template match="nasty-details">
	<H1>Nasty Details</H1>
	<xsl:apply-templates select="*"/>
</xsl:template>

<xsl:template match="example">
	<xsl:apply-templates select="*"/>
</xsl:template>

<xsl:template match="screenshot">
	<CENTER>
	<IMG>
	<xsl:attribute name="src">
	<xsl:value-of select="."/>
	</xsl:attribute>
	<xsl:attribute name="alt">Screenshot</xsl:attribute>
	<xsl:attribute name="class">framed</xsl:attribute>
	</IMG>
	</CENTER>
</xsl:template>

<xsl:template match="orderedlist">
	<OL>
	<xsl:for-each select="listitem">
		<LI>
		<xsl:value-of select="."/>
		</LI>
	</xsl:for-each>
	</OL>
</xsl:template>

<xsl:template match="itemizedlist">
	<UL>
	<xsl:for-each select="listitem">
		<LI>
		<xsl:value-of select="."/>
		</LI>
	</xsl:for-each>
	</UL>
</xsl:template>

<xsl:template match="variablelist">
	<DL>
	<xsl:for-each select="varlistentry">
		<DT>
		<xsl:value-of select="term"/>
		</DT>
		<DD>
		<xsl:value-of select="listitem"/>
		</DD>
	</xsl:for-each>
	</DL>
</xsl:template>

<xsl:template match="screen">
	<PRE>
	<xsl:value-of select="."/>
	</PRE>
</xsl:template>

<xsl:template match="ulink">
	<A href="{@url}">
	<xsl:apply-templates/>
	</A>
</xsl:template>

<xsl:template match="para">
	<P>
	<xsl:apply-templates/>
	</P>
</xsl:template>

</xsl:stylesheet>
